from services import get_installation_id, get_init_system_config

class Config(object):
    MAX_CONTENT_LENGTH = 50 * 1024 * 1024
    UPLOAD_FOLDER = '/tmp'
    DEBUG = False
    TESTING = False
    DATABASE = '/tmp/fmtapper_web.db'
    FMTAPPER_CONFIG_DIR = '/etc/fmtapper'
    FMTAPPER_PROFILES_DIR = FMTAPPER_CONFIG_DIR + '/profiles'
    FMTAPPER_SCHEDULES_DIR_NAME = 'schedules'
    FMTAPPER_SCHEDULES_DIR = FMTAPPER_CONFIG_DIR + '/' + FMTAPPER_SCHEDULES_DIR_NAME
    FMTAPPER_LOGS_DIR = '/var/log/fmtapper'
    FMTAPPER_STATE_DIR = '/var/run/fmtapper'
    FMTAPPER_SOCKET_DIR = '/tmp'
    FMTAPPER_CLEANUP_CONFIG_FILE = FMTAPPER_CONFIG_DIR + '/cleanup_service.conf'
    WRAPPER_SCRIPT_PATH = '/etc/fmtapper/fmtapper_wrapper.sh'
    HOST = '127.0.0.1'
    INSTALLATION_ID_FILE = FMTAPPER_CONFIG_DIR + '/installation_id'
    USERS_FILE = '/etc/fmtapper/users.pwd'
    CLEANUP_SERVICE_LOGS_DIR = '/var/log/fmtapper'
    CLEANUP_SERVICE_LOG_PATTERN = 'cleanup.log'
    SIGNAL_QUALITY_LEVELS = [10, 20, 30, 40, 50]
    SIGNAL_VOLUME_LEVELS = [-40, -24, -18, -12, -6]
    SESSION_COOKIE_NAME = 'session' + get_installation_id(INSTALLATION_ID_FILE).strip('\n')
    NEW_TUNER_TMP_DIR = '/tmp/tapperui/new_tuner'
    APPLY_NETWORK_FILE = '/tmp/tapperui/apply_network'
    STANDART_MP3_FILEPATH = '/home/support/media/{{channel}}/{{year}}_{{month}}_{{day}}/{{hour}}_{{minute}}_{{second}}.mp3'
    FMTAPPER_PORTS_CONFIG_FILE = FMTAPPER_CONFIG_DIR + '/ports.conf'
    METRICS_LIFETIME_SEC = 604800
    INIT_SYSTEM_CONFIG = get_init_system_config()


class DevelopmentConfig(Config):
    DEBUG = True
    HOST = '0.0.0.0'
    WRAPPER_SCRIPT_PATH = '/vagrant/scripts/fmtapper_wrapper.sh'
